## mapserver 8.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0...3.23)

project (MapServer)

if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
      message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:
   mkdir build; cd build; cmake ..
Before that, remove the files created by this failed run:
   rm -rf CMakeCache.txt CMakeFiles")
endif("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")

include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)

set (MapServer_VERSION_MAJOR 8)
set (MapServer_VERSION_MINOR 0)
set (MapServer_VERSION_REVISION 1)
set (MapServer_VERSION_SUFFIX "")

# Set C++ version
# Make CMAKE_CXX_STANDARD available as cache option overridable by user
set(CMAKE_CXX_STANDARD 11
  CACHE STRING "C++ standard version to use (default is 11)")
message(STATUS "Requiring C++${CMAKE_CXX_STANDARD}")
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
message(STATUS "Requiring C++${CMAKE_CXX_STANDARD} - done")

# Set C99 version
# Make CMAKE_C_STANDARD available as cache option overridable by user
set(CMAKE_C_STANDARD 99
  CACHE STRING "C standard version to use (default is 99)")
message(STATUS "Requiring C${CMAKE_C_STANDARD}")
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)
message(STATUS "Requiring C${CMAKE_C_STANDARD} - done")

set(TARGET_VERSION_MAJOR ${MapServer_VERSION_MAJOR})
set(TARGET_VERSION_MINOR ${MapServer_VERSION_MINOR})

MATH(EXPR MapServer_IS_DEV_VERSION "${MapServer_VERSION_MINOR}%2")
if(MapServer_IS_DEV_VERSION)
  set (MapServer_VERSION_STRING "${MapServer_VERSION_MAJOR}.${MapServer_VERSION_MINOR}-dev")
else(MapServer_IS_DEV_VERSION)
  set (MapServer_VERSION_STRING "${MapServer_VERSION_MAJOR}.${MapServer_VERSION_MINOR}.${MapServer_VERSION_REVISION}")
  set (MapServer_VERSION_STRING "${MapServer_VERSION_STRING}${MapServer_VERSION_SUFFIX}")
endif(MapServer_IS_DEV_VERSION)
MATH(EXPR MapServer_VERSION_NUM "${MapServer_VERSION_MAJOR}*10000+${MapServer_VERSION_MINOR}*100+${MapServer_VERSION_REVISION}")

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
foreach(_version IN ITEMS 3.20)
    if(CMAKE_VERSION VERSION_LESS "${_version}")
        list(INSERT CMAKE_MODULE_PATH 0 "${PROJECT_SOURCE_DIR}/cmake/${_version}")
    endif()
endforeach()

if (APPLE)
  set(CMAKE_FIND_FRAMEWORK "LAST")
endif (APPLE)

# Offer the user the choice of overriding the installation directories
set(INSTALL_LIB_DIR lib CACHE PATH "Installation directory for libraries")
set(INSTALL_BIN_DIR bin CACHE PATH "Installation directory for executables")
set(INSTALL_INCLUDE_DIR include CACHE PATH "Installation directory for header files")
if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR CMake)
else()
  set(DEF_INSTALL_CMAKE_DIR share/mapserver/cmake)
endif()
set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")

# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE CMAKE)
  set(var INSTALL_${p}_DIR)
  if(NOT IS_ABSOLUTE "${${var}}")
    set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
  endif()
endforeach()

macro (ms_link_libraries)
  if(BUILD_DYNAMIC)
    target_link_libraries(mapserver ${ARGV})
  endif(BUILD_DYNAMIC)
  if(BUILD_STATIC)
    target_link_libraries(mapserver_static ${ARGV})
  endif(BUILD_STATIC)
endmacro()

macro( report_optional_not_found component )
  message(SEND_ERROR "${component} library/component/dependency could not be found.
  HINTS:
  - disable ${component} support by adding -DWITH_${component}=0
  - add the ${component} install directory to the CMAKE_PREFIX_PATH variable (-DCMAKE_PREFIX_PATH=\"/path/to/${component}-install-dir;/path/to/other/dirs\"")
endmacro()
macro( report_mandatory_not_found component )
  message(SEND_ERROR "${component} library/component could not be found and is a mandatory dependency
  HINT:
  - add the ${component} install directory to the CMAKE_PREFIX_PATH variable (-DCMAKE_PREFIX_PATH=\"/path/to/${component}-install-dir;/path/to/other/dirs\"")
endmacro()
macro( report_dependency_error component dependency)
  message(SEND_ERROR "${component} support requires ${dependency} support, however ${dependency} support has been disabled.
  HINTS:
  - re-run with -DWITH_${dependency}=1 (or without -DWITH_${dependency}=0)
  - disable ${component} support by adding -DWITH_${component}=0"
  )
endmacro()

SET(CMAKE_REQUIRED_INCLUDES "math.h")
if(NOT(WIN32))
SET(CMAKE_REQUIRED_LIBRARIES "m")
endif(NOT(WIN32))

check_function_exists("strrstr"          HAVE_STRRSTR)
check_function_exists("strcasecmp"  HAVE_STRCASECMP)
check_function_exists("strcasestr"  HAVE_STRCASESTR)
check_function_exists("strlcat"  HAVE_STRLCAT)
check_function_exists("strlcpy"  HAVE_STRLCPY)
check_function_exists("strlen"  HAVE_STRLEN)
check_function_exists("strncasecmp"  HAVE_STRNCASECMP)

check_symbol_exists(vsnprintf stdio.h HAVE_VSNPRINTF)
IF(NOT HAVE_VSNPRINTF)
    check_function_exists("vsnprintf"  HAVE_VSNPRINTF)
ENDIF()

check_function_exists("lrintf" HAVE_LRINTF)
check_function_exists("lrint" HAVE_LRINT)

check_include_file(dlfcn.h HAVE_DLFCN_H)


check_c_source_compiles("
int main(int argc, char **argv) {
   long x=0,y=0;
   for(x=0;x<5;x++) {
     if(y>1) break;
     y=__sync_fetch_and_add(&x,1);
   }
}" HAVE_SYNC_FETCH_AND_ADD)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

#options suported by the cmake builder
option(WITH_PROTOBUFC "Choose if protocol buffers support should be built in (required for vector tiles)" ON)
option(WITH_KML "Enable native KML output support (requires libxml2 support)" OFF)
option(WITH_SOS "Enable SOS Server support (requires PROJ and libxml2 support)" OFF)
option(WITH_WMS "Enable WMS Server support (requires PROJ support)" ON)
option(WITH_FRIBIDI "Choose if FriBidi glyph shaping support should be built in (usefull for right-to-left languages) (requires HARFBUZZ)" ON)
option(WITH_HARFBUZZ "Choose if Harfbuzz complex text layout should be included (needed for e.g. arabic and hindi) (requires FRIBIDI)" ON)
option(WITH_ICONV "Choose if Iconv Internationalization support should be built in" ON)
option(WITH_CAIRO "Choose if CAIRO  rendering support should be built in (required for SVG and PDF output)" ON)
option(WITH_SVGCAIRO "Choose if SVG symbology support (via libsvgcairo) should be built in (requires cairo, libsvg, libsvg-cairo. Incompatible with librsvg)" OFF)
option(WITH_RSVG "Choose if SVG symbology support (via librsvg) should be built in (requires cairo, librsvg. Incompatible with libsvg-cairo)" OFF)
option(WITH_MYSQL "Choose if MYSQL joining support should be built in" OFF)
option(WITH_FCGI "Choose if FastCGI support should be built in" ON)
option(WITH_GEOS "Choose if GEOS geometry operations support should be built in" ON)
option(WITH_POSTGIS "Choose if Postgis input support should be built in" ON)
option(WITH_CLIENT_WMS "Enable Client WMS Layer support (requires CURL)" OFF)
option(WITH_CLIENT_WFS "Enable Client WMS Layer support (requires CURL)" OFF)
option(WITH_CURL "Enable Curl HTTP support (required for wms/wfs client, and remote SLD)" OFF)
option(WITH_WFS "Enable WFS Server support (requires PROJ and OGR support)" ON)
option(WITH_WCS "Enable WCS Server support (requires PROJ and GDAL support)" ON)
option(WITH_OGCAPI "Enable OGCAPI Server support (requires PROJ and OGR support)" ON)
option(WITH_LIBXML2 "Choose if libxml2 support should be built in (used for sos, wcs 1.1,2.0 and wfs 1.1)" ON)
option(WITH_THREAD_SAFETY "Choose if a thread-safe version of libmapserver should be built (only recommended for some mapscripts)" OFF)
option(WITH_GIF "Enable GIF support (for PIXMAP loading)" ON)
option(WITH_PYTHON "Enable Python mapscript support" OFF)
option(WITH_PHPNG "Enable PHPNG (SWIG) mapscript support" OFF)
option(WITH_PERL "Enable Perl mapscript support" OFF)
option(WITH_RUBY "Enable Ruby mapscript support" OFF)
option(WITH_JAVA "Enable Java mapscript support" OFF)
option(WITH_CSHARP "Enable C# mapscript support" OFF)
option(WITH_ORACLESPATIAL "include oracle spatial database input support" OFF)
option(WITH_ORACLE_PLUGIN "include oracle spatial database input support as plugin" OFF)
option(WITH_MSSQL2008 "include mssql 2008 database input support as plugin" OFF)
option(WITH_EXEMPI "include xmp output metadata support" OFF)
option(WITH_XMLMAPFILE "include native xml mapfile support (requires libxslt/libexslt)" OFF)
option(WITH_V8 "include javacript v8 scripting" OFF)
option(WITH_PIXMAN "use (experimental) support for pixman for layer compositing operations" OFF)

option(BUILD_STATIC "Also build a static version of mapserver" OFF)
option(LINK_STATIC_LIBMAPSERVER "Link to static version of libmapserver (also for mapscripts)" OFF)
option(WITH_APACHE_MODULE "include (experimental) support for apache module" OFF)
option(WITH_GENERIC_NINT "generic rounding" OFF)
option(WITH_PYMAPSCRIPT_ANNOTATIONS "Add annotations to Python mapscript output" OFF)

option(FUZZER "Build fuzzers using libFuzzer" OFF)
mark_as_advanced(FUZZER)

#TODO: USE_OGL? , USE_SDE, USE_CLUSTER_EXTERNAL USE_CLUSTER_PLUGIN, USE_MSSQL2008, USE_MSSQL2008_PLUGIN
# SIGNORE_MISSING_DATA, CGI_CL_DEBUG_ARGS, EXTRA DEBUG FLAGS?,
# PERLV_ld_DETECT?

# Add compiler flags for warnings
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUCC OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror=format-security")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror=format-security")
endif()

if(FUZZER)
    if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        message(FATAL_ERROR "Need clang for libFuzzer support")
    endif()

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=fuzzer,address -DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=fuzzer,address -DFUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION")
endif()

if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set(_LIBDIR_DEFAULT "lib")
  # Override this default 'lib' with 'lib64' iff:
  #  - we are on Linux system but NOT cross-compiling
  #  - we are NOT on debian
  #  - we are on a 64 bits system
  # reason is: amd64 ABI: http://www.x86-64.org/documentation/abi.pdf
  # Note that the future of multi-arch handling may be even
  # more complicated than that: http://wiki.debian.org/Multiarch
  if(CMAKE_SYSTEM_NAME MATCHES "Linux"
      AND NOT CMAKE_CROSSCOMPILING
      AND NOT EXISTS "/etc/debian_version")
    if(NOT DEFINED CMAKE_SIZEOF_VOID_P)
      message(AUTHOR_WARNING
        "Unable to determine default CMAKE_INSTALL_LIBDIR directory because no target architecture is known. "
        "Please enable at least one language before including GNUInstallDirs.")
    else()
      if("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")
        set(_LIBDIR_DEFAULT "lib64")
      endif()
    endif()
  endif()
  set(CMAKE_INSTALL_LIBDIR "${_LIBDIR_DEFAULT}" CACHE PATH "object code libraries (${_LIBDIR_DEFAULT})")
endif()

SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
SET(CMAKE_MACOSX_RPATH ON)

if(LINK_STATIC_LIBMAPSERVER)
  set(BUILD_STATIC 1)
  set(BUILD_DYNAMIC 0)
  set(MAPSERVER_LIBMAPSERVER mapserver_static)
else(LINK_STATIC_LIBMAPSERVER)
  set(BUILD_DYNAMIC 1)
  set(MAPSERVER_LIBMAPSERVER mapserver)
endif(LINK_STATIC_LIBMAPSERVER)

set(agg_SOURCES
renderers/agg/src/agg_arc.cpp
renderers/agg/src/agg_vcgen_dash.cpp
renderers/agg/src/agg_vcgen_contour.cpp
renderers/agg/src/agg_curves.cpp
renderers/agg/src/agg_embedded_raster_fonts.cpp
renderers/agg/src/agg_trans_affine.cpp
renderers/agg/src/agg_vcgen_stroke.cpp
renderers/agg/src/agg_font_freetype.cpp
renderers/agg/src/agg_line_aa_basics.cpp
renderers/agg/src/clipper.cpp
)
include_directories(renderers/agg/include)

set(v8_SOURCES
  mapscript/v8/v8_object_wrap.hpp  
  mapscript/v8/point.cpp
  mapscript/v8/line.cpp
  mapscript/v8/shape.cpp  
  mapscript/v8/v8_mapscript.cpp
  mapv8.cpp
)
include_directories(mapscript/v8/)

=== mapscript/perl/CMakeLists.txt ===
find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})
find_package(Perl REQUIRED)
find_package(PerlLibs REQUIRED)
set(CUSTOM_PERL_SITE_ARCH_DIR ${PERL_SITEARCH} CACHE STRING "Custom installation directory for perl binary extension")
include_directories(${PERL_INCLUDE_PATH})
include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
add_definitions(${PERL_EXTRA_C_FLAGS})
set(CMAKE_SWIG_FLAGS -shadow -w314)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/perl)

if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
    swig_add_library(perlmapscript TYPE MODULE LANGUAGE perl5 SOURCES ../mapscript.i)
else ()
    swig_add_module(perlmapscript perl5 ../mapscript.i)
endif ()

SWIG_LINK_LIBRARIES(perlmapscript ${PERL_LIBRARIES} ${MAPSERVER_LIBMAPSERVER})
set_target_properties(perlmapscript PROPERTIES OUTPUT_NAME mapscript)
set_target_properties(perlmapscript PROPERTIES PREFIX "")
if(APPLE)
  set_target_properties(perlmapscript PROPERTIES SUFFIX ".bundle")
endif(APPLE)

install(FILES $<TARGET_FILE:${SWIG_MODULE_perlmapscript_REAL_NAME}> DESTINATION ${CUSTOM_PERL_SITE_ARCH_DIR}/auto/mapscript)
install(FILES $<TARGET_FILE_DIR:${SWIG_MODULE_perlmapscript_REAL_NAME}>/mapscript.pm DESTINATION ${CUSTOM_PERL_SITE_ARCH_DIR})

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/tests DESTINATION  ${CMAKE_CURRENT_BINARY_DIR})
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/examples DESTINATION  ${CMAKE_CURRENT_BINARY_DIR})

=== debian/changelog ===
mapserver (8.0.1-4ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:03:12 +0000

mapserver (8.0.1-4ubuntu1) noble; urgency=medium

  * d/rules: define -D_BSD_SOURCE to ensure that strlcpy/strlcat functions
    are declared (LP: #2058864).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Mon, 25 Mar 2024 15:19:52 +1300

mapserver (8.0.1-4build3) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:08:52 +0000

mapserver (8.0.1-4build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:10:37 +0000

mapserver (8.0.1-4build1) noble; urgency=medium

  * No-change rebuild for libtirpc t64.

 -- Matthias Klose <doko@debian.org>  Sun, 03 Mar 2024 05:44:19 +0100

mapserver (8.0.1-4) unstable; urgency=medium

  * Add dpkg-dev (>= 1.22.5) to build dependencies for t64 changes.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 02 Mar 2024 13:27:40 +0100

mapserver (8.0.1-3) unstable; urgency=medium

  * Replace pkg-config build dependency with pkgconf.
  * Update symbols for other architectures.
  * Move from experimental to unstable.
    (closes: #1062837)

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 28 Feb 2024 15:59:13 +0100

mapserver (8.0.1-3~exp1) experimental; urgency=medium

  * Re-instate MapScript Java bindings.
  * Export DEB_PYTHON_INSTALL_LAYOUT=deb_system instead of patching
    `setup.py install` to use --install-layout=deb.
  * Use execute_{before,after} instead of override in rules file.
  * Enable Salsa CI.
  * Switch to dh-sequence-*.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 05 Feb 2024 14:16:19 +0100

mapserver (8.0.1-2.1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Graham Inggs <ginggs@debian.org>  Sat, 03 Feb 2024 19:10:20 +0000

mapserver (8.0.1-2) unstable; urgency=medium

  * Don't run dh_python3 on example scripts.
    (closes: #1038735)
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 20 Jun 2023 19:24:25 +0200

mapserver (8.0.1-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Drop MapScript Java bindings, ca-certificates-java fails to install.
  * Bump debhelper compat to 13.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 12 Jun 2023 06:16:05 +0200

mapserver (8.0.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Add Rules-Requires-Root to control file.
  * Bump Standards-Version to 4.6.2, no changes.
  * Use dh_python3 to fix shebang instead of a patch.
  * Update obsolete freetype build dependency.
  * Update lintian overrides.
  * Update copyright file.
  * Update docs filenames.
  * Update symbols for amd64.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 17 Apr 2023 19:59:18 +0200

=== debian/control ===
Source: mapserver
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Alan Boudreault <aboudreault@mapgears.com>,
           Bas Couwenberg <sebastic@debian.org>
Section: devel
Priority: optional
Build-Depends: ant,
               cmake (>= 3.0),
               chrpath,
               debhelper-compat (= 13),
               default-jdk,
               dh-php,
               dh-python,
               dh-sequence-pkgkde-symbolshelper,
               dh-sequence-python3,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               dpkg-dev (>= 1.22.5),
               libcairo2-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libfcgi-dev,
               libfreetype-dev,
               libfribidi-dev,
               libgdal-dev (>= 1.10.1-0~),
               libgeos-dev (>= 3.3.1-1~),
               libgif-dev,
               libharfbuzz-dev,
               libjpeg-dev,
               libperl-dev,
               libpng-dev,
               libprotobuf-c-dev,
               libpq-dev,
               libproj-dev,
               librsvg2-dev,
               libxml2-dev,
               libxslt1-dev,
               php-dev,
               pkgconf,
               pkg-kde-tools,
               protobuf-c-compiler,
               python3,
               python3-dev,
               python3-setuptools,
               swig,
               xsltproc,
               zlib1g-dev (>= 1.1.4)
Build-Conflicts: libcurl3-openssl-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/mapserver
Vcs-Git: https://salsa.debian.org/debian-gis-team/mapserver.git
Homepage: https://mapserver.org
Rules-Requires-Root: no

Package: libmapserver2t64
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: cgi-mapserver,
          mapserver-bin,
          mapserver-doc,
          libmapscript-perl,
          python3-mapscript
Pre-Depends: ${misc:Pre-Depends}
Provides: ${t64:Provides}
Breaks: libmapserver2 (<< ${source:Version})
Replaces: libmapserver2
Description: Shared library for MapServer
 This package contains the shared library.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: libmapserver-dev
Architecture: any
Section: libdevel
Depends: libmapserver2t64 (= ${binary:Version}),
         ${misc:Depends}
Suggests: cgi-mapserver,
          mapserver-bin,
          mapserver-doc,
          libmapscript-perl,
          php-mapscript-ng,
          python3-mapscript
Description: Shared library development files for MapServer
 This package contains the development files for the shared library.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: cgi-mapserver
Architecture: any
Section: web
Depends: mapserver-bin,
         ${misc:Depends}
Suggests: mapserver-doc,
          libmapscript-perl,
          php-mapscript-ng,
          python3-mapscript
Description: CGI executable for MapServer
 This package contains the mapserv CGI program. It provides the
 MapServer template language, and can be used to implement Web Map
 Service applications.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: mapserver-bin
Architecture: any
Section: misc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: cgi-mapserver,
          mapserver-doc,
          shapelib,
          libmapscript-perl,
          php-mapscript-ng,
          python3-mapscript
Breaks: libmapserver-dev (<< 8.0.0-2~)
Replaces: libmapserver-dev (<< 8.0.0-2~)
Description: MapServer utilities
 This package provides command-line utilities for MapServer.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: mapserver-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: cgi-mapserver,
          libmapscript-perl,
          php-mapscript-ng,
          python3-mapscript
Description: documentation for MapServer
 This package provides some brief documentation for MapServer.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: php-mapscript-ng
Architecture: any
Section: php
Depends: ${php:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Description: PHP MapServer module (SWIG)
 PHP MapScript provides MapServer functions for PHP scripts.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.
 .
 This package provides MapScript for PHP based on SWIG.

Package: libmapscript-perl
Architecture: any
Section: perl
Depends: ${perl:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Conflicts: perl-mapscript
Provides: perl-mapscript
Replaces: perl-mapscript
Description: Perl MapServer module
 Perl MapScript module provides MapServer functions for Perl scripts.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

Package: python3-mapscript
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Description: Python library for MapServer
 Python MapScript provides MapServer functions for Python scripts.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

Package: libmapscript-java
Architecture: any
Section: java
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Description: Java library for MapServer
 Java MapScript provides MapServer functions for Java applications.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_PYTHON_INSTALL_LAYOUT=deb_system

include /usr/share/dpkg/pkg-info.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -D_BSD_SOURCE
CFLAGS   := $(shell dpkg-buildflags --get CFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

CFLAGS += $(CPPFLAGS)
CFLAGS += $(LDFLAGS)

MANPAGES := $(wildcard debian/man/*.*.xml)

MS_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')
BUILD_DATE := $(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")

%:
	dh $@ --with php \
	      --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	                     -DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
	                     -DCMAKE_MODULE_LINKER_FLAGS="$(LDFLAGS)" \
	                     -DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)" \
	                     -DCMAKE_INSTALL_PREFIX=/usr \
	                     -DCMAKE_VERBOSE_MAKEFILE=1 \
	                     -DINSTALL_LIB_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)" \
	                     -DWITH_KML=1 \
	                     -DWITH_SOS=1 \
	                     -DWITH_WMS=1 \
	                     -DWITH_FRIBIDI=1 \
	                     -DWITH_HARFBUZZ=1 \
	                     -DWITH_ICONV=1 \
	                     -DWITH_CAIRO=1 \
	                     -DWITH_SVGCAIRO=0 \
	                     -DWITH_RSVG=1 \
	                     -DWITH_MYSQL=0 \
	                     -DWITH_FCGI=1 \
	                     -DWITH_GEOS=1 \
	                     -DWITH_POSTGIS=1 \
	                     -DWITH_CURL=1 \
	                     -DWITH_CLIENT_WMS=1 \
	                     -DWITH_CLIENT_WFS=1 \
	                     -DWITH_WFS=1 \
	                     -DWITH_WCS=1 \
	                     -DWITH_LIBXML2=1 \
	                     -DWITH_THREAD_SAFETY=1 \
	                     -DWITH_GIF=1 \
	                     -DWITH_ORACLESPATIAL=0 \
	                     -DWITH_ORACLE_PLUGIN=0 \
	                     -DWITH_MSSQL2008=0 \
	                     -DWITH_EXEMPI=0 \
	                     -DWITH_XMLMAPFILE=0 \
	                     -DWITH_V8=0 \
	                     -DWITH_PIXMAN=0 \
	                     -DWITH_PYTHON=1 \
	                     -DWITH_PHPNG=1 \
	                     -DWITH_PERL=1 \
	                     -DWITH_RUBY=0 \
	                     -DWITH_JAVA=1 \
	                     -DWITH_CSHARP=0

execute_before_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

override_dh_auto_test:
	# msautotest submodule is not used

execute_after_dh_auto_install:
	# removing embedded rpath in binaries
	-find $(CURDIR)/debian/tmp/usr/bin -type f -exec chrpath --delete {} \;

	# removing embedded rpath in libraries
	-find $(CURDIR)/debian/tmp/usr/lib -name "*.so*" -type f -exec chrpath --delete {} \;

	$(RM) $(CURDIR)/debian/tmp/etc/mapserver-sample.conf

override_dh_installchangelogs:
	dh_installchangelogs HISTORY.md

override_dh_compress:
	dh_compress -X.xml -X.xsd -X.xsl

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(MS_VERSION)

override_dh_python3:
	dh_python3 -ppython3-mapscript --shebang=/usr/bin/python3

override_dh_perl:
	dh_perl -plibmapscript-perl

override_dh_java:
	dh_java -plibmapscript-java

## mapserver 8.0.2

=== mapscript/python/CMakeLists.txt ===
find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})

find_package (Python REQUIRED COMPONENTS Interpreter Development)

include_directories(${Python_INCLUDE_DIRS})
include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/python)

set(SwigFile ${PROJECT_SOURCE_DIR}/mapscript/mapscript.i)

# add and comments annotations to py file output - requires >= SWIG 4.1
if (WITH_PYMAPSCRIPT_ANNOTATIONS AND ${Python_VERSION_MAJOR} GREATER_EQUAL 3)
  set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -doxygen)
  if (${Python_VERSION_MINOR} GREATER_EQUAL 6)
     set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -features python:annotations=c)
  else ()
     set_property(SOURCE ${SwigFile} APPEND PROPERTY SWIG_FLAGS -features python:annotations=c,python:annotations:novar)
  endif ()
endif ()

if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
    swig_add_library(pythonmapscript TYPE MODULE LANGUAGE python SOURCES ${SwigFile})
else ()
    swig_add_module(pythonmapscript python ${SwigFile})
endif ()

swig_link_libraries(pythonmapscript ${Python_LIBRARIES} ${MAPSERVER_LIBMAPSERVER})

set_target_properties(${SWIG_MODULE_pythonmapscript_REAL_NAME} PROPERTIES PREFIX "")
set_target_properties(${SWIG_MODULE_pythonmapscript_REAL_NAME} PROPERTIES OUTPUT_NAME _mapscript)

set(SETUP_PY_IN "${PROJECT_SOURCE_DIR}/mapscript/python/setup.py.in")
set(SETUP_PY_TEMP "${CMAKE_CURRENT_BINARY_DIR}/setup.py.temp")

configure_file(${SETUP_PY_IN} ${SETUP_PY_TEMP} @ONLY)
file(READ ${SETUP_PY_TEMP} SETUP_CONTENT)

# each target (e.g. Debug, Release etc.) will have a copy of setup.py

file(GENERATE OUTPUT $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/setup.py INPUT ${SETUP_PY_TEMP})

if(MSVC)
    set(OUTPUT_FOLDER ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_BUILD_TYPE})
else()
    # for non-Windows builds there are no build type subfolders (e.g. Release, Debug etc.)
    set(OUTPUT_FOLDER ${CMAKE_CURRENT_BINARY_DIR})
endif()

if(WIN32)
    # Windows venv binaries are in a different location than Linux
    set(Python_VENV_SCRIPTS ${OUTPUT_FOLDER}/mapscriptvenv/Scripts)
else()
    set(Python_VENV_SCRIPTS ${OUTPUT_FOLDER}/mapscriptvenv/bin)
endif()

add_custom_target(
    pythonmapscript-wheel
    DEPENDS mapscripttests.stamp
)

add_custom_command(
    DEPENDS ${SWIG_MODULE_pythonmapscript_REAL_NAME}
    OUTPUT mapscriptvenv.stamp
    WORKING_DIRECTORY ${OUTPUT_FOLDER}
    COMMAND ${Python_EXECUTABLE} -m pip install pip --upgrade
    COMMAND ${Python_EXECUTABLE} -m pip install virtualenv
    COMMAND ${Python_EXECUTABLE} -m virtualenv mapscriptvenv
    COMMAND ${Python_VENV_SCRIPTS}/pip install -r ${PROJECT_SOURCE_DIR}/mapscript/python/requirements-dev.txt > requires.log
    COMMENT "Creating a Python virtual environment and installing the required packages"
)

add_custom_command(
    DEPENDS mapscriptvenv.stamp
    OUTPUT mapscriptlinting.stamp
    WORKING_DIRECTORY ${OUTPUT_FOLDER}
    COMMAND ${Python_VENV_SCRIPTS}/flake8 $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests --max-line-length=140
    COMMAND ${Python_VENV_SCRIPTS}/flake8 $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/examples --max-line-length=120
    COMMENT "Linting test suite and examples with flake8" # note only one comment is output per custom command block
)

add_custom_command(
    DEPENDS mapscriptlinting.stamp
    OUTPUT mapscriptwheel.stamp
    WORKING_DIRECTORY ${OUTPUT_FOLDER}
    COMMAND ${Python_VENV_SCRIPTS}/python setup.py bdist_wheel > wheel_build.log
    COMMENT "Building the mapscript Python wheel"
)

add_custom_command(
    WORKING_DIRECTORY ${Python_VENV_SCRIPTS} # make sure scripts aren't run when from the same folder as mapscript.py
    DEPENDS mapscriptwheel.stamp
    OUTPUT mapscripttests.stamp
    COMMAND ${Python_VENV_SCRIPTS}/pip install --no-index --find-links=${OUTPUT_FOLDER}/dist mapscript
    # ERROR: file or package not found: mapscript.tests (missing __init__.py?) is caused by
    # ImportError: DLL load failed while importing _mapscript: The specified module could not be found.
    COMMAND ${Python_VENV_SCRIPTS}/python -m pytest --pyargs mapscript.tests
    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.project_csv ${PROJECT_SOURCE_DIR}/tests/cities.csv 2 1 EPSG:4326 EPSG:3857 > test.csv
    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.shpdump ${PROJECT_SOURCE_DIR}/tests/polygon.shp > shpdump.txt
    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.shpinfo ${PROJECT_SOURCE_DIR}/tests/polygon.shp > shpinfo.txt
    COMMAND ${Python_VENV_SCRIPTS}/python -m mapscript.examples.wxs ${PROJECT_SOURCE_DIR}/tests/test.map > response.xml
    COMMENT "Installing the Python wheel and testing it in the virtual environment, then running tests and examples"
)

add_custom_command(
    TARGET ${SWIG_MODULE_pythonmapscript_REAL_NAME}
    WORKING_DIRECTORY ${OUTPUT_FOLDER}
    POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/mapscript/python/mapscript/__init__.py" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/__init__.py
    COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_BINARY_DIR}/mapscript.py" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/mapscript.py
    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:${SWIG_MODULE_pythonmapscript_REAL_NAME}>" "$<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/$<TARGET_FILE_NAME:${SWIG_MODULE_pythonmapscript_REAL_NAME}>"
    COMMAND ${CMAKE_COMMAND} -E copy "${PROJECT_SOURCE_DIR}/mapscript/python/README.rst" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/README.rst
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/mapscript/python/tests/cases" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/tests" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/tests/data
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/mapscript/python/examples" $<TARGET_FILE_DIR:${SWIG_MODULE_pythonmapscript_REAL_NAME}>/mapscript/examples
    COMMENT "Copying files required to build Mapscript"
)

install(  
  CODE "
  
    SET(ENV{PYTHONPATH} \${Python_SITELIB}:\$ENV{PYTHONPATH})
      
    if(DEFINED ENV{DESTDIR})
      SET(PYTHON_ROOT \"--root=\$ENV{DESTDIR}\")
    endif()
  
    if(DEFINED CMAKE_INSTALL_PREFIX)
      SET(PYTHON_PREFIX \"--prefix=\${CMAKE_INSTALL_PREFIX}\")
    endif()

    execute_process(
      COMMAND ${Python_EXECUTABLE} setup.py install \${PYTHON_ROOT} \${PYTHON_PREFIX}
      WORKING_DIRECTORY ${OUTPUT_FOLDER}
    )
  "
)

message(STATUS "CMake Version: ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}")
message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
message(STATUS "Python MapScript output directory: ${OUTPUT_FOLDER}")
message(STATUS "Python Executable: ${Python_EXECUTABLE}")
message(STATUS "Python Version: ${Python_VERSION}")
message(STATUS "Python site packages: ${Python_SITELIB}")

=== debian/changelog ===
mapserver (8.0.2-1) unstable; urgency=high

  * New upstream release.
  * Update upstream branch in gbp.conf.
  * Update watch file to match only 8.0 releases.
  * Update copyright file.
  * Drop spelling-errors.patch, applied upstream.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 12 Jun 2024 05:46:07 +0200

mapserver (8.0.1-5) unstable; urgency=medium

  * Add patch to fix FTBFS with glibc 2.38.
    (closes: #1067651)
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 08 May 2024 18:48:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: mapserver
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
            Alan Boudreault <aboudreault@mapgears.com>,
            Bas Couwenberg <sebastic@debian.org>

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/-/./g \
https://download.osgeo.org/mapserver/ \
(?:.*/)?(?:rel|v|mapserver)[\-\_]?(8\.0\.\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## mapserver 8.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0...3.23)
+cmake_minimum_required(VERSION 3.0...3.29)
 
 project (MapServer)
 
@@ -16,8 +16,8 @@
 include(CheckCSourceCompiles)
 
 set (MapServer_VERSION_MAJOR 8)
-set (MapServer_VERSION_MINOR 0)
-set (MapServer_VERSION_REVISION 1)
+set (MapServer_VERSION_MINOR 2)
+set (MapServer_VERSION_REVISION 0)
 set (MapServer_VERSION_SUFFIX "")
 
 # Set C++ version
@@ -120,6 +120,10 @@
 check_function_exists("strlcpy"  HAVE_STRLCPY)
 check_function_exists("strlen"  HAVE_STRLEN)
 check_function_exists("strncasecmp"  HAVE_STRNCASECMP)
+
+IF((HAVE_STRLCAT OR HAVE_STRLCPY) AND CMAKE_SYSTEM_NAME MATCHES "Linux")
+    add_definitions(-D_DEFAULT_SOURCE)
+ENDIF()
 
 check_symbol_exists(vsnprintf stdio.h HAVE_VSNPRINTF)
 IF(NOT HAVE_VSNPRINTF)
@@ -187,8 +191,13 @@
 option(WITH_GENERIC_NINT "generic rounding" OFF)
 option(WITH_PYMAPSCRIPT_ANNOTATIONS "Add annotations to Python mapscript output" OFF)
 
-option(FUZZER "Build fuzzers using libFuzzer" OFF)
+option(FUZZER "Build fuzzers using libFuzzer (requires Clang, will disable executable - mapserv, etc. - generation)" OFF)
 mark_as_advanced(FUZZER)
+option(BUILD_FUZZER_REPRODUCER "Build fuzzer reproducer programs" ON)
+
+if(FUZZER AND BUILD_FUZZER_REPRODUCER)
+    message(FATAL_ERROR "FUZZER and BUILD_FUZZER_REPRODUCER options are mutually exclusive")
+endif()
 
 #TODO: USE_OGL? , USE_SDE, USE_CLUSTER_EXTERNAL USE_CLUSTER_PLUGIN, USE_MSSQL2008, USE_MSSQL2008_PLUGIN
 # SIGNORE_MISSING_DATA, CGI_CL_DEBUG_ARGS, EXTRA DEBUG FLAGS?,
@@ -234,8 +243,10 @@
   set(CMAKE_INSTALL_LIBDIR "${_LIBDIR_DEFAULT}" CACHE PATH "object code libraries (${_LIBDIR_DEFAULT})")
 endif()
 
-SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
-SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+if(NOT DEFINED CMAKE_INSTALL_RPATH)
+  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
+  SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+endif()
 SET(CMAKE_MACOSX_RPATH ON)
 
 if(LINK_STATIC_LIBMAPSERVER)
@@ -248,26 +259,7 @@
 endif(LINK_STATIC_LIBMAPSERVER)
 
 set(agg_SOURCES
-renderers/agg/src/agg_arc.cpp
-renderers/agg/src/agg_vcgen_dash.cpp
-renderers/agg/src/agg_vcgen_contour.cpp
-renderers/agg/src/agg_curves.cpp
-renderers/agg/src/agg_embedded_raster_fonts.cpp
-renderers/agg/src/agg_trans_affine.cpp
-renderers/agg/src/agg_vcgen_stroke.cpp
-renderers/agg/src/agg_font_freetype.cpp
-renderers/agg/src/agg_line_aa_basics.cpp
-renderers/agg/src/clipper.cpp
-)
-include_directories(renderers/agg/include)
-
-set(v8_SOURCES
-  mapscript/v8/v8_object_wrap.hpp  
-  mapscript/v8/point.cpp
-  mapscript/v8/line.cpp
-  mapscript/v8/shape.cpp  
-  mapscript/v8/v8_mapscript.cpp
-  mapv8.cpp
-)
-include_directories(mapscript/v8/)
-
+src/renderers/agg/src/agg_arc.cpp
+src/renderers/agg/src/agg_vcgen_dash.cpp
+src/renderers/agg/src/agg_vcgen_contour.cpp
+src/renderers/agg/src/agg_curves.cpp

=== src/mapscript/phpng/CMakeLists.txt ===
find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})
if(WIN32 AND ((${CMAKE_VERSION} EQUAL "3.12.0") OR (${CMAKE_VERSION} EQUAL "3.12.1") OR (${CMAKE_VERSION} EQUAL "3.12.2") OR (${CMAKE_VERSION} EQUAL "3.12.3")))
    message(FATAL_ERROR "Building with CMAKE ${CMAKE_VERSION} will not work. Please downgrade to 3.11.x or update to a higher version than 3.12.3")
endif()

if(WIN32)
  FIND_PACKAGE(SWIG 3.0.11 REQUIRED)
  if(WITH_THREAD_SAFETY)
    FIND_PACKAGE(SWIG 4.0.0 REQUIRED)
  endif(WITH_THREAD_SAFETY)
endif(WIN32)

FIND_PACKAGE(PHP REQUIRED)
INCLUDE(UseSWIG)

if(WIN32)
  add_definitions(/DWIN32 /DZEND_WIN32 /DPHP_WIN32 /DZEND_DEBUG=0)
  if(NOT CMAKE_CL_64)
    add_definitions(-D_USE_32BIT_TIME_T)
  endif(NOT CMAKE_CL_64)
  if(WITH_THREAD_SAFETY)
    add_definitions(-DZTS=1)
  endif(WITH_THREAD_SAFETY)
endif(WIN32)

include_directories(${PHP_INCLUDE_PATH})
message(STATUS "PHP Include Path: ${PHP_INCLUDE_PATH}")

include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/swiginc)
include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/)
include_directories(${PROJECT_SOURCE_DIR}/src/mapscript/phpng)
include_directories(${CMAKE_CURRENT_BINARY_DIR}) # make sure mapscriptPHP7_wrap.c is found

if(WIN32)
  include_directories(${PHP_INCLUDE_PATH}/win32)
endif(WIN32)

IF(PHP_VERSION LESS 5)
  MESSAGE(FATAL_ERROR "PHP version is not 5 or later")
ENDIF(PHP_VERSION LESS 5)

IF(PHP_VERSION LESS 7)
  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
      SWIG_ADD_LIBRARY(php_mapscriptng TYPE MODULE LANGUAGE php SOURCES ../mapscript.i)
  else ()
      swig_add_module(php_mapscriptng php ../mapscript.i)
  endif ()
ELSE()
  if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.7)
      SWIG_ADD_LIBRARY(php_mapscriptng TYPE MODULE LANGUAGE php7 SOURCES ../mapscript.i)
  else ()
      swig_add_module(php_mapscriptng php7 ../mapscript.i)
  endif ()
ENDIF(PHP_VERSION LESS 7)

if(WIN32)
  target_compile_options(php_mapscriptng PRIVATE /DWIN32 /DZEND_WIN32 /DPHP_WIN32 /DZEND_DEBUG=0)
  if(WITH_THREAD_SAFETY)
    target_compile_options(php_mapscriptng PRIVATE /DZTS=1)
  endif(WITH_THREAD_SAFETY)
  SWIG_LINK_LIBRARIES(php_mapscriptng ${PHP_LIBRARY})
endif(WIN32)

IF(APPLE)
  if(XCODE)
     SET(CMAKE_C_LINK_FLAGS 
        "${CMAKE_C_LINK_FLAGS} -undefined dynamic_lookup")
     SET(CMAKE_CXX_LINK_FLAGS 
        "${CMAKE_CXX_LINK_FLAGS} -undefined dynamic_lookup")
  else(XCODE)
     SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS 
        "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -undefined dynamic_lookup")
     SET(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS 
        "${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
  endif(XCODE)
ENDIF(APPLE)

# hide "defined but not used" warnings
target_compile_options(php_mapscriptng PRIVATE -Wno-unused-label)

target_link_libraries(php_mapscriptng mapserver)
set_target_properties(${SWIG_MODULE_mapscript_REAL_NAME} PROPERTIES PREFIX "")

if(NOT WIN32)
  install(TARGETS php_mapscriptng DESTINATION ${PHP_EXTENSION_DIR})
  # check if we must install the required file containing MapServer constants and functions
  if(${SWIG_VERSION} LESS_EQUAL 4.0.2)
     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mapscript.php DESTINATION ${PHP_EXTENSION_DIR} COMPONENT dev)
  endif()
endif()

=== debian/changelog ===
mapserver (8.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Strip pre-releases from symbols version.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 08 Jul 2024 20:18:24 +0200

mapserver (8.2.0~rc3-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 Jun 2024 15:46:36 +0200

mapserver (8.2.0~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Refresh patches.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 Jun 2024 06:35:35 +0200

mapserver (8.2.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 14 Jun 2024 19:10:35 +0200

mapserver (8.2.0~beta3-1~exp1) experimental; urgency=medium

  * New upstream beta release.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 12 Jun 2024 05:25:33 +0200

mapserver (8.2.0~beta2-1~exp1) experimental; urgency=medium

  * New upstream beta release.
  * Drop patches applied upstream.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 08 Jun 2024 21:10:54 +0200

mapserver (8.2.0~beta1-1~exp1) experimental; urgency=medium

  * New upstream beta release.
  * Update copyright file.
  * Drop patches applied upstream. Refresh remaining patches.
  * Add python3-pip to build dependencies.
  * Update paths for source tree restructuring.
  * Add patch to fix Python MapScript installation.
  * Update symbols for amd64.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 07 Jun 2024 07:06:59 +0200
